#    Name:	"Replace_CI_Definition"
#		This is a modification of "scale_reinit" by Matt666 under use of "Scale Reset", "Reset Scale Rotation" by sdmitch with use of code lines of "Scale Definition" by TIG
#    Modified by:	faust07 in June 2018
#    Usage:	Replace leave component instances generatet with the "LiveIvy" plugin with there definition for rendering with indigo/indigoRT (and others)
#    Reason:	Indigo cannot place this instances correctly if the last element in the transformation matrix is not equal to 1.0

def repl_definit
	model = Sketchup.active_model
	sel = model.selection
	model.start_operation ("replace definition")
	sel.to_a.each{|e|next if e.class!=Sketchup::ComponentInstance
	repl_cinstance(e)
	}
	model.commit_operation
end

def repl_cinstance(ent_old)
	orig = ent_old.transformation.origin
	t = ent_old.transformation.to_a
	scf = t[15]
	ent_new = Sketchup.active_model.active_entities.add_instance(ent_old.definition, orig) 
	ent_old.erase!
	t[12] = orig.x;	t[13] = orig.y;	t[14] = orig.z;	t[15] = 1
	ent_new.transformation = ent_new.transformation.set! t
	tr_sc = Geom::Transformation.scaling orig, (1.0/scf), (1.0/scf), (1.0/scf)
	ent_new.transform! tr_sc
end

def self.scale_reinit_ok
	model = Sketchup.active_model
	model.selection.each do |e|
		if e.typename == "ComponentInstance" 
			return true if (e.bounds.diagonal != e.definition.bounds.diagonal) and not e.definition.behavior.always_face_camera? and not e.definition.behavior.shadows_face_sun?
		elsif e.typename == "Group"
			return true if e.bounds.diagonal != e.definition.bounds.diagonal
		end
	end
	return false
end

class Sketchup::Group 
	def definition
		Sketchup.active_model.definitions.each do |d|
			d.instances.each{|i| return d if i == self}
		end
	end
end

if not file_loaded?("Replace_CI_Definition.rb")
	UI.add_context_menu_handler do |menu|
		menu.add_item("Replace_CI_Definition"){ repl_definit } if scale_reinit_ok
	end

end
file_loaded("Replace_CI_Definition.rb")